﻿' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください
Option Strict On

Imports System.Net.Http
Imports Windows.UI.Popups

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public Class dicInfo
    Public Property 英文 As String
    Public Property 意味 As String
End Class

Public NotInheritable Class MainPage
    Inherits Page

    Protected Overrides Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
    End Sub

    Private Async Sub okButton_Click(sender As Object, e As RoutedEventArgs) Handles okButton.Click
        If dicTextBox.Text <> String.Empty Then
            Dim dicUri = String.Format("http://public.dejizo.jp/NetDicV09.asmx/SearchDicItemLite?Dic=EdictJE&Word={0}&Scope=HEADWORD&Match=STARTWITH&Merge=AND&Prof=XML&PageSize=20&PageIndex=0", Uri.EscapeDataString(dicTextBox.Text))
            Dim myHttpClient As New HttpClient
            Dim resultDicXml = Await myHttpClient.GetStringAsync(dicUri)
            resultDicXml = resultDicXml.Replace("<SearchDicItemResult xmlns:xsi=" & ChrW(34) & "http://www.w3.org/2001/XMLSchema-instance" & ChrW(34) & " xmlns:xsd=" & ChrW(34) & "http://www.w3.org/2001/XMLSchema" & ChrW(34) & " xmlns=" & ChrW(34) & "http://btonic.est.co.jp/NetDic/NetDicV09" & ChrW(34) & ">", "<SearchDicItemResult >")
            Dim dicXmlDoc As XElement = XElement.Parse(resultDicXml)
            Dim myItemCount = dicXmlDoc.Descendants("ItemCount").Value
            If myItemCount = "0" Then
                Dim message = New MessageDialog("該当する単語がありません。")
                Await message.ShowAsync
                Exit Sub
            End If

            Dim myDicList As New List(Of dicInfo)
            For Each result In From c In dicXmlDoc.Descendants("DicItemTitle") Select c
                Dim dicItem = result.Element("ItemID").Value
                Dim resultDicUri = String.Format("http://public.dejizo.jp/NetDicV09.asmx/GetDicItemLite?Dic=EdictJE&Item={0}&Loc=&Prof=XML", dicItem)
                Dim myDicHttpClient As New HttpClient
                Dim resultMeanXml = Await myDicHttpClient.GetStringAsync(resultDicUri)
                resultMeanXml = resultMeanXml.Replace("<GetDicItemResult xmlns:xsi=" & ChrW(34) & "http://www.w3.org/2001/XMLSchema-instance" & ChrW(34) & " xmlns:xsd=" & ChrW(34) & "http://www.w3.org/2001/XMLSchema" & ChrW(34) & " xmlns=" & ChrW(34) & "http://btonic.est.co.jp/NetDic/NetDicV09" & ChrW(34) & ">", "<GetDicItemResult>")
                resultMeanXml = resultMeanXml.Replace("<div class=" & ChrW(34) & "NetDicBody" & ChrW(34) & " xml:space=" & ChrW(34) & "preserve" & ChrW(34) & " xmlns=" & ChrW(34) & ChrW(34) & ">", "<div>")

                Dim meanXmlDoc As XElement = XElement.Parse(resultMeanXml)
                Dim english = meanXmlDoc.Descendants("span").Value
                Dim mean = meanXmlDoc.Descendants("Body").Elements("div").Elements("div").Value

                myDicList.Add(New dicInfo With {.英文 = english, .意味 = mean})

            Next
            GridView1.ItemsSource = myDicList
        Else
            dicTextBox.Focus(Windows.UI.Xaml.FocusState.Pointer)
            Exit Sub
        End If
    End Sub
    Private Async Sub myApps_Click(sender As Object, e As RoutedEventArgs) Handles myApps.Click
        Dim myAppsUri = New Uri("ms-windows-store:Search?query=kuniyasu")
        Await Windows.System.Launcher.LaunchUriAsync(myAppsUri)
    End Sub
End Class
